<template>
  <div class="container">
    <v-form>
      <v-container>
        <v-row>
          <h2>Inicio de sesión</h2>
        </v-row>
        <v-row>
          <v-col cols="12" sm="6" md="3">
            <v-text-field v-model="user.email" label="Correo"></v-text-field>
          </v-col>

          <v-col cols="12" sm="6" md="3">
            <v-text-field v-model="user.pass" type="password" label="Contraseña"></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-btn color="teal lighten-1" @click="login">Entrar</v-btn>
        </v-row>
      </v-container>
    </v-form>
    <v-form>
      <v-container>
        <v-row>
          <h2>Registro</h2>
        </v-row>
        <v-row>
          <v-col cols="12" sm="6" md="3">
            <v-text-field v-model="reg.name" label="Nombre"></v-text-field>
          </v-col>

          <v-col cols="12" sm="6" md="3">
            <v-text-field v-model="reg.lastname" label="Apellido"></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" sm="6" md="3">
            <v-text-field v-model="reg.email" label="Correo"></v-text-field>
          </v-col>

          <v-col cols="12" sm="6" md="3">
            <v-text-field v-model="reg.pass" type="password" label="Contraseña"></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-btn color="teal lighten-1" :disabled="!valid" @click="register">Registrarse</v-btn>
        </v-row>
      </v-container>
    </v-form>
  </div>
</template>


<script>
import { mapActions } from "vuex";
export default {
  data() {
    return {
      user: {
        email: "",
        pass: ""
      },
      reg: {
        name: "",
        lastname: "",
        pass: "",
        email: ""
      }
    };
  },
  computed: {
    valid: function() {
      if (
        !this.reg.name ||
        !this.reg.lastname ||
        !this.reg.pass ||
        !this.reg.email
      ) {
        return false;
      } else {
        return true;
      }
    }
  },
  methods: {
    ...mapActions(["saveUser"]),
    login() {
      this.axios
        .post("/auth/login", this.user)
        .then(res => {
          const token = res.data.token;
          this.saveUser(token);
        })
        .catch(e => {
          console.log(e.response);
        });
    },
    register() {
      this.axios
        .post("/auth/register", this.reg)
        .then(res => {
          this.registerUser();
        })
        .catch(e => {
          console.log(e.response);
        });
    },
    registerUser() {
      this.reg.lastname = "";
      this.reg.name = "";
      this.reg.pass = "";
      this.reg.email = "";
    }
  }
};
</script>

<style>
</style>